

; Box85 - v1.0
; By Kaid [kaid@excite.fr]


.INCLUDE USGARD.H
.ORG 0
.DB "Box85 by Kaid",0

NB_LVL   = 8                    ;Number of levels

BUFFER_T = TEXT_MEM             ;Tableau en cours
MEC_POS  = TEXT_MEM+112         ;Position du mec dans le tableau
MEC_TEX  = TEXT_MEM+113         ;Texture se trouvant sous le mec
NB_BOX   = TEXT_MEM+114         ;Nombre de caisses dans le tableau

;                        *** Menu ***

Menu:

        ROM_CALL(CLEARLCD)      ;On efface l'cran texte

        LD DE,VIDEO_MEM+48      ;On affiche l'image de titre
        LD HL,&ImgTit-1
        #FNCALL ZCP

BoucleMenu:
        CALL GET_KEY            ;Attend la pression d'une touche

        OR A                    ;
        JR Z,BoucleMenu         ;Pas de touche, on boucle

        CP K_F3                 ;
        JR Z,QuitteBox          ;On quitte Box85

        CP K_F1                 ;
        JR Z,Charge             ;On charge le niveau actuel

        CP K_F2                 ;Si ce n'est pas F2, on boucle
        JR NZ,BoucleMenu        ;Sinon, on recommence au premier niveau

        LD A,1                  ;        
        LD (&NumLvl),A          ;Premier niveau


;                       *** Boucle du jeu ***
Charge:

        CALL &ChargeNiveau      ;Charge le niveau
        CALL &AffNiveau         ;Affiche le niveau

BoucleJeu:
        CALL GET_KEY            ;Attend la pression d'une touche

        OR A                    ;
        JR Z,BoucleJeu          ;Pas de touche, on boucle

        CP K_EXIT               ;
        JR Z,Menu               ;On retourne au menu

        CP K_LEFT               ;
        JR Z,DeplGauche         ;Dplacement  gauche

        CP K_RIGHT              ;
        JR Z,DeplDroite         ;Dplacement  droite

        CP K_UP                 ;
        JR Z,DeplHaut           ;Dplacement en haut

        CP K_DOWN               ;
        JR Z,DeplBas            ;Dplacement en bas

        CP K_SECOND             ;Boss key ?
        JR NZ,BoucleJeu         ;Non, pas d'autres choix, on boucle


; Boss Key
        CALL OTH_SHUTDOWN       ;Met la Ti en veille
        LD HL,USG_BITS          ;Permet de retourner directement au shell de
        SET 1,(HL)              ; la Ti. Merci  Jimmy Mardell!
        RET                     ;

        


; Dplacement  gauche
DeplGauche:

        LD BC,$003D             ;Code de 'DEC A \ NOP'
        JR TestEtatJeu

; Dplacement  droite
DeplDroite:

        LD BC,$003C             ;Code de 'INC A \ NOP'
        JR TestEtatJeu

; Dplacement en bas
DeplBas:

        LD BC,$0EC6             ;Code de 'ADD A,14'
        JR TestEtatJeu


; Dplacement en haut
DeplHaut:

        LD BC,$0ED6             ;Code de 'SUB 14'

; Teste l'tat du jeu
TestEtatJeu:

        CALL &GereDeplacements  ;Gre les dplacements

        LD A,(NB_BOX)           ;Si le nombre de caisses dans le niveau
        OR A                    ; n'est pas de zro, le jeu continue
        JR NZ,BoucleJeu         ;                                                        

        LD A,NB_LVL             ;A=Nombre de niveaux
        LD HL,&NumLvl           ;HL pointe sur le niveau actuel

        CP (HL)                 ;
        JR Z,FinDuJeu           ;Si A=(HL), c'est la fin du jeu

        INC (HL)                ;On passe au niveau suivant, 
        JR Charge               ; et on le charge

; Fin du jeu
FinDuJeu:
        LD HL,$0603             ;                
        LD (CURSOR_ROW),HL      ;
        LD HL,&Str_Win          ;
        CALL D_ZT_STR           ;On le signale

        CALL OTH_PAUSE          ;On fait une pause 


; Quitte Box85
QuitteBox:

        ROM_CALL(CLEARTEXT)     ;Efface l'cran et la mmoire vido
        RET                     ;On quitte ...



;Gre les dplacements
GereDeplacements:

        LD A,(MEC_POS)
        CALL &ProchaineCase     ;A=Contenu de la prochaine case

        CP 1 \ RET Z            ;C'est un mur, le dplacement est impossible

        CP 4 \ RET Z            ;C'est une caisse range, le dplacement est
                                ; impossible

        CP 2                    ;
        JR NZ,PasUneCaisse      ;Si A!=2, le joueur ne pousse pas une caisse

;Ici le joueur pousse une caisse

        PUSH HL
        PUSH DE
        LD A,E                  ;
        CALL &ProchaineCase2    ;A contient le contenu de la prochaine case
        POP DE

        OR A                    ;
        JR Z,DeplOk             ;Il n'y a rien, le dplacement est ok

        CP 3                    ;
        JR Z,EmpOk              ;Il y a un emplacement, c'est aussi ok

        POP HL                  
        RET                     ;Quitte la routine, dplassement impossible

;Le joueur place la caisse dans un emplacement
EmpOk:
        PUSH HL
        LD HL,NB_BOX            ;
        DEC (HL)                ;Dcrmente le nombre de caisses restantes
        POP HL
        LD (HL),4               ;On remplace la case par une caisse range
        JR FinDepl

;Le joueur dplace simplement la caisse
DeplOk:
        LD (HL),2               ;On remplace la case par la caisse

FinDepl:
        POP HL
        XOR A                   ;A la place de la case, il n'y aura rien

PasUneCaisse:

        PUSH AF                 ;Sauve A (Contenu de la prochaine case)

        LD (HL),5               ;On replace notre mec

        PUSH DE
        LD A,(MEC_POS)          ;
        CALL &DonneCase         ;HL pointe sur la position du mec dans le tableau
        POP DE

        LD A,(MEC_TEX)          ;
        LD (HL),A               ;On restaure l'ancienne texture

        POP AF

        LD (MEC_TEX),A          ;On sauve la nouvelle
        LD A,E
        LD (MEC_POS),A          ;Et la position du mec 

        CALL &AffNiveau         ;On r-affiche le niveau
        RET


; * Donne les infos sur la case o le joueur veut aller *
;   Entre: A =Position du mec
;           BC=Contient le code pour modifier A
;   Sortie: A =Contenu de la case o le mec veut aller
;           HL=Pointe sur cette case dans le tableau

ProchaineCase:

        LD HL,&OpCode
        LD (HL),C
        INC HL
        LD (HL),B

ProchaineCase2:

OpCode  .DW 0

DonneCase:
        LD D,0 \ LD E,A
        LD HL,BUFFER_T
        ADD HL,DE
        LD A,(HL)
        RET


; * Affiche <B> chaines verticalement *
;   Entre: B =Nombre de lignes
;           DE=Position initiale du curseur
;           HL=Pointe sur les chaines
;   Sortie: X

Aff_N_Lgn:
        LD (CURSOR_ROW),DE      ;On place le curseur        
        ROM_CALL(D_ZT_STR)      ;        

        INC DE                  ;

        DJNZ Aff_N_Lgn
        RET




; * Affichage d'un sprite de 8x8. *
;   Entre: DE=Pointe sur la destination
;           HL=Pointe sur le sprite
;   Sortie: X

Aff_Sprite:
        PUSH BC
        PUSH DE
        LD A,8                  ;A=Hauteur du sprite

Aff_Elem_Boucle:
        LDI

        LD B,15                 ;On ajoute 15  DE pour se placer sur la
Add_12:                         ; prochaine ligne
        INC DE  \ DJNZ Add_12   ;

        DEC A                   ;Dcrmente A
        JR NZ,Aff_Elem_Boucle   ;Boucle tant que toutes les lignes ne sont
                                ; pas affiches.

        POP DE
        POP BC
        RET




;* Affiche le niveau  l'cran *
AffNiveau:

        LD HL,GRAPH_MEM         ;
        LD BC,1024-1            ;
        CALL OTH_CLEAR          ;Vide notre buffer

        LD HL,BUFFER_T          ;Source: le niveau
        LD DE,GRAPH_MEM+1       ;Destination: la mmoire graphique

        LD B,8                  ;Nombre de lignes 

AffNiveau_Lgn:
        PUSH BC
        LD B,14                 ;Nombre de colonnes

AffNiveau_Col:
        LD A,(HL)               ;A contient une case du niveau
        INC HL

        OR A                    ;
        JR Z,PasDeSprite        ;Si A=0, pas de sprite  afficher

        PUSH HL
        PUSH DE
        DEC A
        SLA A \ SLA A \ SLA A
        LD E,A  \ LD D,0        ;DE=A*8 (8=Taille d'un sprite)
        LD HL,&Spr_Mur          ;HL pointe sur le premier sprite
        ADD HL,DE               ;HL pointe maintenant sur le bon sprite
        POP DE
        CALL &Aff_Sprite        ;On l'affiche
        POP HL

PasDeSprite:
        INC DE
        DJNZ AffNiveau_Col

        PUSH HL                 ;
        LD HL,7*16+2            ;
        ADD HL,DE               ;
        EX DE,HL                ;
        POP HL                  ;Ajuste DE pour pointer sur la prochaine ligne.

        POP BC
        DJNZ AffNiveau_Lgn

        LD DE,VIDEO_MEM         ;
        LD HL,GRAPH_MEM         ;
        LD BC,1024              ;On copie la mmoire graphique vers la mmoire
        LDIR                    ; vido pour afficher le niveau

        RET



ChargeNiveau:

;Charge le niveau

        LD A,(&NumLvl)          ;
        LD B,A                  ;B=Niveau en cours

        LD HL,&Niveaux-30       ;Pointe avant le premier niveau
        LD DE,30                ;DE=Taille d'un niveau

AjusteNiveau:
        ADD HL,DE               ;On ajoute DE  HL tant que nous ne sommes
        DJNZ AjusteNiveau       ; pas au bon niveau


        LD A,(HL)               ;HL pointe sur le nombre de caisses dans le niveau
        LD (NB_BOX),A           ;On le sauve
        INC HL

        LD A,(HL)               ;HL pointe sur la position initiale du mec
        LD (MEC_POS),A          ;On la sauve
        INC HL
        PUSH AF                 ;Sauve A

;On va dcompresser le niveau

        LD DE,BUFFER_T          ;Destination
        LD B,28                 ;Taille du niveau compress

Decomp_Boucle:

        PUSH BC
        LD B,4                  ;Nombre de cases par niveau
        LD C,0                  ;Nombre initial de dcalages

Decomp_1o:
        CALL &Decomp            ;Dcompresse une case
        DJNZ Decomp_1o          ;Boucle pour dcompresser les 4

        POP BC
        INC HL                  ;Pointe sur le prochain octet compress
        DJNZ Decomp_Boucle


        POP AF                  ;Restaure A (Position initiale du mec)
        LD DE,BUFFER_T
        LD L,A \ LD H,0
        ADD HL,DE               ;HL=Pointe sur la position initiale du mec

        LD (HL),5               ;On le place

        XOR A                   ;
        LD (MEC_TEX),A          ;L'ancienne case est vide


;Affiche le niveau en cours

        ROM_CALL(CLEARLCD)      ;Efface l'cran

        LD HL,$0803             ;
        LD (CURSOR_ROW),HL      ;
        LD A,(&NumLvl)          ;
        LD L,A \ LD H,0         ;
        CALL D_HL_DECI          ;Affiche le numro du niveau

        LD HL,$0503             ;
        LD (CURSOR_ROW),HL      ;
        LD HL,&Str_Lvl          ; 
        CALL D_ZT_STR           ;Ajoute "Level"

        CALL OTH_PAUSE          ;On fait une pause

        RET


; *Dcompresse une case*
;   Entre: C =Nombre de dcalages
;           DE=Pointe sur la destination
;           HL=Pointe sur l'octet compress
;   Sortie: C+=2
;           DE++

Decomp:
        PUSH BC
        LD B,(HL)               ;B=Un octet compress
        LD A,C                  ;A=Nombre de dcalage

Decal_B:
        OR A                    ;
        JR Z,FinDecal           ;

        DEC A                   ;
        SRA B                   ;
        JR Decal_B              ;On effectue les dcalages ncessaires

FinDecal:
        LD A,B
        AND %00000011           ;On ne garde que les deux premiers octects
        LD (DE),A               ;On place la case dans la destination
        INC DE                  ;Incrmente le pointeur de destination
        POP BC
        INC C \ INC C           ;C=+2, pour le nombre de dcalages
        RET


; Niveau en cours
NumLvl  .DB 1

; Chaines
Str_Win .DB "You win!",0
Str_Lvl .DB "Level",0

;Sprites
Spr_Mur .DB %11111111
        .DB %10000001
        .DB %10101011
        .DB %10010101 
        .DB %10101011
        .DB %10010101 
        .DB %10101011    
        .DB %11111111

Spr_Box .DB %11111111
        .DB %11000011
        .DB %10100101
        .DB %10011001
        .DB %10011001
        .DB %10100101
        .DB %11000011    
        .DB %11111111

Spr_Emp .DB %00000000
        .DB %00000000
        .DB %00000000
        .DB %00011000
        .DB %00011000
        .DB %00000000
        .DB %00000000    
        .DB %00000000

Spr_Pla .DB %11111111
        .DB %11000011
        .DB %10111101
        .DB %10111101
        .DB %10111101
        .DB %10111101
        .DB %11000011    
        .DB %11111111

Spr_Mec .DB %00000000
        .DB %00000000
        .DB %00011000
        .DB %00111100
        .DB %00111100
        .DB %00011000
        .DB %00000000    
        .DB %00000000

;Image de prsentation
ImgTit  .DB $87,$7F,$76,$08,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0
        .DB $C0,$C0,$C0,$C0,$95,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5
        .DB $B5,$B5,$B5,$B0,$84,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4
        .DB $D4,$D4,$D4,$D4,$81,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB
        .DB $AB,$AB,$AB,$AB,$08,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA
        .DB $CA,$CA,$CA,$CA,$C0,$95,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5
        .DB $B5,$B5,$B5,$B5,$B0,$87,$7F,$76,$08,$C0,$C0,$3F,$23,$C0,$C0,$95,$B0,$3F
        .DB $25,$D5,$C0,$92,$D0,$3F,$25,$CA,$C0,$95,$B0,$3F,$25,$D5,$C0,$92,$D0,$3B
        .DB $FE,$0B,$50,$80,$CA,$C0,$95,$B0,$39,$4A,$0A,$50,$80,$D5,$C0,$9F,$F1,$4B
        .DB $2D,$4D,$08,$50,$80,$48,$08,$C0,$C7,$4A,$2B,$F8,$8F,$08,$F0,$10,$C0,$C0
        .DB $95,$B1,$4D,$29,$F8,$83,$E0,$9C,$12,$D5,$C0,$92,$D1,$E0,$8F,$28,$F0,$81
        .DB $E0,$9C,$12,$CA,$C0,$95,$B1,$E0,$87,$28,$F0,$81,$E0,$9C,$12,$D5,$C0,$92
        .DB $D1,$E0,$87,$28,$F0,$81,$E0,$9C,$12,$CA,$C0,$95,$B1,$E0,$87,$08,$FC,$87
        .DB $0A,$F0,$BC,$80,$F0,$8E,$13,$D5,$C0,$9F,$F1,$E0,$86,$81,$48,$83,$C0,$9C
        .DB $83,$E0,$9C,$81,$E0,$0F,$48,$08,$D5,$C7,$80,$F8,$8F,$FF,$83,$C0,$F0,$83
        .DB $F0,$F0,$83,$49,$0C,$D5,$C0,$92,$D1,$4B,$80,$F8,$9E,$87,$87,$0B,$4A,$0A
        .DB $4D,$0A,$CA,$C0,$95,$B1,$4C,$81,$E0,$9C,$8E,$8E,$0A,$4A,$0A,$4E,$09,$D5
        .DB $C0,$92,$D1,$4D,$87,$09,$F0,$B9,$E0,$81,$E3,$F8,$81,$C0,$9F,$08,$CA,$C0
        .DB $95,$B1,$E0,$8F,$8E,$08,$F0,$9F,$C0,$83,$C0,$BC,$12,$49,$95,$B0,$87,$FC
        .DB $B8,$81,$F3,$C0,$8E,$81,$F0,$80,$F0,$81,$E0,$0F,$E1,$CF,$F8,$82,$82,$9C
        .DB $08,$F3,$C0,$8E,$81,$F0,$81,$E0,$80,$F0,$0F,$D2,$C8,$88,$82,$D6,$9C,$08
        .DB $F3,$C0,$8E,$81,$F0,$81,$E0,$80,$F0,$0F,$CC,$CA,$D8,$82,$AA,$9C,$08,$F3
        .DB $C0,$8E,$83,$F8,$81,$E0,$80,$F0,$0F,$CC,$C9,$A8,$82,$D6,$9C,$08,$F3,$E0
        .DB $8E,$87,$9C,$81,$E0,$80,$F0,$0F,$D2,$CA,$D8,$82,$AA,$9C,$80,$F8,$F0,$8E
        .DB $87,$87,$80,$F8,$08,$F0,$0E,$F0,$E4,$D4,$81,$AB,$8E,$81,$F8,$BC,$8F,$83
        .DB $C3,$C0,$9E,$08,$F0,$90,$8F,$4D,$AB,$08,$48,$8F,$4A,$81,$4A,$83,$C0,$F0
        .DB $8F,$C0,$FC,$87,$C3,$48,$87,$FF,$08,$C0,$C7,$4A,$08,$49,$83,$C0,$9C,$83
        .DB $4C,$80,$4A,$87,$A5,$C0,$C0,$95,$B1,$4A,$0C,$FC,$87,$0A,$F0,$8F,$48,$08
        .DB $49,$A5,$CC,$EA,$E0,$89,$A8,$3B,$FF,$0E,$FE,$B3,$99,$CA,$C0,$95,$B0,$3F
        .DB $15,$CC,$E9,$B5,$B0,$84,$D4,$3F,$17,$D2,$F0,$F2,$D0,$85,$AC,$3F,$17,$E1
        .DB $4A,$AB,$08,$7F,$79,$08,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0
        .DB $C0,$C0,$C0,$C0,$C0,$C0,$95,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5
        .DB $B5,$B5,$B5,$B5,$B5,$B0,$84,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4,$D4
        .DB $D4,$D4,$D4,$D4,$D4,$D4,$81,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB,$AB
        .DB $AB,$AB,$AB,$AB,$AB,$AB,$08,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA,$CA
        .DB $CA,$CA,$CA,$CA,$CA,$CA,$C0,$95,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5,$B5
        .DB $B5,$B5,$B5,$B5,$B5,$B5,$B0,$87,$7F,$76,$3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F
        .DB $0C,$7F,$51,$30,$7F,$51,$30,$E0,$12,$E0,$15,$E0,$12,$E0,$2B,$E1,$D0,$81
        .DB $86,$E0,$84,$08,$CC,$8E,$85,$80,$E0,$2B,$E2,$99,$D5,$C6,$D2,$B6,$B5,$B6
        .DB $84,$A8,$E0,$B0,$2C,$E1,$92,$D9,$86,$E5,$A4,$D6,$A6,$86,$92,$C0,$B0,$2C
        .DB $E0,$D2,$D1,$86,$D6,$94,$D4,$A6,$84,$92,$C0,$B0,$2C,$E3,$89,$D0,$C6,$D3
        .DB $B2,$B4,$96,$87,$AA,$A0,$B0,$2C,$00



Niveaux:
#INCBIN LEVELS.PAK
.END
